#include "LTC6903.h"

#include <math.h>

LTC6903::LTC6903(PropWare::SPI *spibus, PropWare::Port::Mask CS) {
	//this->_CS = CS;
	//this->_SCLK = SCLK;
	//this->_SDI = SDI;
	this->_spibus = spibus;
	this->_CS = PropWare::Pin(CS, PropWare::Pin::Dir::OUT);
	this->_CS.high();
}

void LTC6903::SetManual(uint16_t oct, uint16_t dac) {
	unsigned char CNF = 0b00000010;
	uint32_t BitMap = (oct << 12) | (dac << 2) | CNF;
	//shift_out(this->_SDI, this->_SCLK, MSBFIRST, BitMap, 16);

	this->_CS.low();
	this->_spibus->shift_out(16, BitMap);
	this->_CS.high();
}

void LTC6903::SetFrequency(uint32_t freq) {
	uint16_t _oct = 3.322 * log10(freq / 1039);

#define Round(d) (d - floor(d) > 0.5) ? ceil(d) : floor(d)
	uint16_t _dac = Round(2048 - ((2078 * pow(2, 10 + _oct)) / freq));
#undef Round

	SetManual(_oct, _dac);
}