#include "SN76489.h"
#include <unistd.h>

SN76489::SN76489(PropWare::SimplePort *bus, PropWare::Pin::Mask WE) {
	_bus = bus;
	//GPIOB->regs->CRL = (GPIOB->regs->CRL & 0xFF0FFFFF) | 0x00300000; //_WE OUTPUT
	//GPIOB->regs->ODR |= 0x20; //_WE HIGH

	this->_WE = PropWare::Pin(WE, PropWare::Pin::Dir::OUT);
	this->_WE.set();

	this->psgFrqLowByte = 0;
}

void SN76489::Reset() {
	Write(0x9F);
	Write(0xBF);
	Write(0xDF);
	Write(0xFF);
}

void SN76489::Send(uint8_t data) {
  //PSG noise channel fix
  //A bunny fixed the hi-hat for ya'll.
	if ((data & 0x80) == 0) {
		if ((this->psgFrqLowByte & 0x0F) == 0) {
			if ((data & 0x3F) == 0)
				this->psgFrqLowByte |= 1;
		}
		Write(this->psgFrqLowByte);
		Write(data);
	} else if ((data & 0x90) == 0x80 && (data & 0x60) >> 5 != 3)
		this->psgFrqLowByte = data;
	else
		Write(data);
}

void SN76489::Write(uint8_t data) {
	//GPIOB->regs->ODR |= 0x20; //_WE HIGH
	//_bus->Write(data);
	//GPIOB->regs->ODR &= ~(0x20); //_WE_LOW
	//delayMicroseconds(14);
	//GPIOB->regs->ODR |= 0x20; //_WE HIGH

	/*high(this->_WE);
	//OUTA |= data << this->_D;
	this->_bus->Write(data);
	low(this->_WE);
	usleep(14);
	high(this->_WE);*/

#ifdef FLIPBUS
	data = ~data;
#endif

	this->_WE.high();
	this->_bus->write(data);
	this->_WE.low();
	usleep(14);
	this->_WE.high();
}